<?php
// +---------------------------------------------------------------------------+
// | GL-CAPTCHA for Geeklog                                                    |
// +---------------------------------------------------------------------------|
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Orignal Author of captcha.class.php                                       |
// |    Pascal Rehfeldt <Pascal@Pascal-Rehfeldt.com>                           |
// |                                                                           |
// | Adapted for Geeklog by: Mark R. Evans <mevans@ecsnet.com>                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

error_reporting(E_ALL);
require_once('../lib-common.php');

// +---------------------------------------------------------------------------+
// | Configuration                                                             |
// +---------------------------------------------------------------------------+
// | $gfxDriver - specifies which graphics driver to use:                      |
// |                0 - GD Libs                                                |
// |                1 - ImageMagick                                            |
// |                2 - No Graphics driver, use Static Images                  |
// |                                                                           |
// | $gfxFormat - specifies the format of the CAPTCHA graphic (only valid for  |
// |              when $gfxDriver is 0 or 1)                                   |
// |                jpg - Use jpg images                                       |
// |                png - Use PNG images                                       |
// |                                                                           |
// | $gfxPath   - specifies the full path to ImageMagick's convert program     |
// |                i.e.; /usr/local/bin/convert                               |
// |                                                                           |
// | $debug     - turns on/off debug logging in Geeklog's error.log file.      |
// |                0 = off                                                    |
// |                1 = on                                                     |
// |                                                                           |
// +---------------------------------------------------------------------------+

$gfxFormat  = "jpg";                      // png or jpg
$gfxDriver  = 0;                          // 0=GD 1=ImageMagick 2=STATIC images
$gfxPath    = "/usr/local/bin/convert";   // Full path to ImageMagick convert
$debug      = 0;                          // 0=off 1=verbose logging

/* ---- Do not change anything below this line ---- */

//Start the session
session_start();

//Load the Class
require('./class/captcha.class.php');

//Create a CAPTCHA
$captcha = new captcha();

//Store the String in a session
$_SESSION['CAPTCHAString'] = $captcha->getCaptchaString();

?>
