<?php
// +---------------------------------------------------------------------------+
// | CAPTCHA for Geeklog                                                       |
// +---------------------------------------------------------------------------+
// | CAPTCHA Class                                                             |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author: Pascal Rehfeldt <Pascal@Pascal-Rehfeldt.com>                      |
// |                                                                           |
// | Adapted for Geeklog by: Mark R. Evans <mevans@ecsnet.com>                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

error_reporting(E_ALL);

require('./class/filter.class.php');
require('./class/error.class.php');

$cString = array('0EYP0S','1F770D','28XOYI','2LDUMD','47TXJC','4ITVAP','4JKOGQ','5E66T1','5LSG1C','6URYYP','7G1AG0','7GZY5S','7Q2WOZ','7SMW7J','83EY3L','8C99ZZ','8MNIAX','8N91KL','8NFLWQ','8RL5MD','9KR3EJ','BI1ZCZ','BPHOX9','BRWLVK','BZTIGV','C0HK4F','C2QOUK','CFE1YM','CJANGI','CQY9FX','CXUH5S','CYO0Y1','DHGFOZ','DQFRUI','DUZCN2','E5SZ52','ECGLOZ','EE37I4','ELWSDN','F6A0KP','F7VU1K','FZAL8O','G5DCR5','G9J7VC','GBHHGT','GFACI5','GP6LL9','GXIRNW','H5FLY1','HH0NAF','HWYMU6','I0VFY9','I0W79K','I121OQ','I1AZAU','I7CQIR','IIOGVW','IKF3O4','IKJM7C','INNH12','IO0H0L','IWXXTN','J7XDFF','JF4UH8','JSMSI9','K1LUBX','K55DZL','KIFH52','KVKZU2','L3QMM1','LRW7O3','MFWUDW','ML976T','N1KL1P','O3UV7A','OB87BK','ODH566','OE8PKO','OOHUIW','PSWO3K','PZ4CS0','Q1PAGZ','R8OVM4','RAKUHA','SK908O','TDGQSM','TG3ZTE','U4IG9B','U5R7PW','UJ97BE','VANJZK','VN6QKH','VPLW5R','VTZDK1','VUYFUH','WJDUK2','WP0QYS','XDIYL2','XUKG66','YE9U9N','YQ73D3','YTWL2C','ZNF56M','ZYO016');

class captcha {
    var $Length;
    var $CaptchaString;
    var $fontpath;
    var $bgpath;
    var $fonts;
    var $backgrounds;

    var $driver;
    var $convertpath;
    var $gfxformat;
    var $debug;

    function captcha ($length = 6) {
        global $gfxDriver, $gfxFormat, $gfxPath, $debug;

        $this->driver       = $gfxDriver;
        $this->convertpath  = $gfxPath;
        $this->gfxformat    = $gfxFormat;
        $this->debug        = $debug;
        $this->sizemin      = "34";
        $this->sizemax      = "34";
        $this->blurmin      = "1";
        $this->blurmax      = "5";
        $this->anglemin     = "-5";
        $this->anglemax     = "5";
        $this->swirlmin     = "10";
        $this->swirlmax     = "15";
        $this->wavemin      = "1";
        $this->wavemax      = "5";
        
        if ($this->driver == 2 ) { // static images
	        $this->stringGen();
    	    $this->makeCaptcha();
	    } else {
	        $this->Length   = $length;
	
	        $this->fontpath = dirname($_SERVER['SCRIPT_FILENAME']) . '/fonts/';
	        $this->bgpath   = dirname($_SERVER['SCRIPT_FILENAME']) . '/backgrounds/';
	
	        $this->fonts       = $this->getFonts();
	        $this->backgrounds = $this->getBackGrounds();
	
	        $errormgr       = new error;
	
	        if ($this->fonts == FALSE) {
	            $errormgr->addError('No fonts available!');
	            $errormgr->displayError();
	            die();
	        }
	
	        if (function_exists('imagettftext') == FALSE && $this->driver == 0) {
	            $errormgr->addError('');
	            $errormgr->displayError();
	            die();
	        }
	
	        $this->stringGen();
	        $this->makeCaptcha();
        }
    }

    function getFonts () {
        $fonts = array();

        if ($handle = @opendir($this->fontpath)) {
            while (($file = readdir($handle)) !== FALSE) {
                $extension = strtolower(substr($file, strlen($file) - 3, 3));
                if ($extension == 'ttf') {
                    $fonts[] = $file;
                }
            }
            closedir($handle);
        } else {
            return FALSE;
        }

        if (count($fonts) == 0) {
            return FALSE;
        } else {
            return $fonts;
        }
    } //getFonts

    function getBackGrounds () {
        $backgrounds = array();

        if ($handle = @opendir($this->bgpath)) {
            while (($file = readdir($handle)) !== FALSE) {
                $extension = strtolower(substr($file, strlen($file) - 3, 3));
                if ($extension == $this->gfxformat) {
                    $backgrounds[] = $file;
                }
            }
            closedir($handle);
        } else {
            return FALSE;
        }

        if (count($backgrounds) == 0) {
            return FALSE;
        } else {
            return $backgrounds;
        }
    } //getBackGrounds


    function getRandFont () {
        return $this->fontpath . $this->fonts[mt_rand(0, count($this->fonts) - 1)];
    } //getRandFont

    function getRandBackground () {
        return $this->bgpath . $this->backgrounds[mt_rand(0, count($this->backgrounds) - 1)];
    } //getRandBackground


    function stringGen () {
	    
	    if ( $this->driver == 2 ) { // static
    	    $i = mt_rand(0,103);
	        $this->CaptchaString = $i;
        } else {
	        $uppercase  = range('A', 'Z');
	        //$lowercase  = range('a', 'z');
	        $numeric    = range(0, 9);
	
	        $CharPool   = array_merge($uppercase, $numeric);
	        $PoolLength = count($CharPool) - 1;
	
	        for ($i = 0; $i < $this->Length; $i++) {
	            $this->CaptchaString .= $CharPool[mt_rand(0, $PoolLength)];
	        }
        }
    } //StringGen

    function makeCaptcha () {
        global $cString, $_CONF;

        if ( $this->driver == 2 ) { // static images
	        header('Content-type: image/jpeg');
    	    $filename = $cString[$this->CaptchaString] . '.jpg';
        	$fp = fopen($_CONF['path'] . '/captcha-images/' . $filename, 'r');
        	if ( $fp != NULL ) {
	           	while (!feof($fp)) {
					$buf = fgets($fp, 8192);
              		echo $buf;
           		}
           		fclose($fp);
        	}
    	} else {
			if ( $this->gfxformat != 'png' && $this->gfxformat != 'jpg') {
	        	header('Content-type: image/gif');
	            COM_errorLog("CAPTCHA: No valid gfxFormat specified");
	            $errormgr = new error;
	            $errormgr->addError('');
	            $errormgr->displayError();
	            die();
			}
	
			$header = 'Content-type: image/' . $this->gfxformat;
	 		header($header);
	
	        if ( $this->driver == 0 ) {
	            $imagelength = $this->Length * 25 + 16;
	            $imageheight = 75;
	            $image       = imagecreate($imagelength, $imageheight);
	            $bgcolor     = imagecolorallocate($image, 255, 255, 255);
	            $stringcolor = imagecolorallocate($image, 0, 0, 0);
	            $filter      = new filters;
	            $filter->signs($image, $this->getRandFont());
	            for ($i = 0; $i < strlen($this->CaptchaString); $i++) {
					imagettftext($image, 25, mt_rand(-15, 15), $i * 25 + 10,
	                        mt_rand(30, 70),
	                        $stringcolor,
	                        $this->getRandFont(),
	                        $this->CaptchaString{$i});
	            }
	        	switch ($this->gfxformat ) {
	            	case 'png' :
	                	imagepng($image);
	               		break;
	            	case 'jpg' :
	                	imagejpeg($image);
	                	break;
				}
	            imagedestroy($image);
	        } else {
	            // ImageMagick code originally written by
	            // Thom Skrtich  (email : bisohpthom@supertwist.net)
	            // used in SecureImage a CAPTCHA plugin for WordPress.
	            $gravities = array('West', 'Center', 'East');
	//            $gravity = $gravities[rand(0, count($gravities)-1)];
	            $gravity = 'Center';
	            # modify the image according to the generated settings
	            $size =  rand($this->sizemin,  $this->sizemax);
	            $blur =  rand($this->blurmin,  $this->blurmax);
	            $angle = rand($this->anglemin, $this->anglemax);
	            $swirl = rand($this->swirlmin, $this->swirlmax);
	            $wave =  rand($this->wavemin,  $this->wavemax);
	
				$cString = $this->CaptchaString;
				$i = strlen($cString);
				$newString = '';
				for ($x=0; $x<$i;$x++) {
					$newString .= $cString[$x];
				  	$newString .= ' ';
				}
	
	            # prepare our image magick command
	            $cmd    = $this->convertpath;
	            $cmd .= ' -font "'.$this->getRandFont().'"';
	            #$cmd .= ' -fill "'.$color.'"';
	            $cmd .= ' -pointsize '.$size;
	            $cmd .= ' -gravity "'.$gravity.'"';
	            $cmd .= ' -annotate 0 \'' . $newString . '\'';
	            $cmd .= ' -blur '.$blur;
	            $cmd .= ' -rotate '.$angle;
	            $cmd .= ' -swirl '.$swirl;
	            $cmd .= ' -wave '.$wave.'x80';
	            $cmd .= ' ' . $this->getRandBackground() . ' - ';
	            
	        	if ($this->debug) {
	            	COM_errorLog("CAPTCHA cmd: " . $cmd);
	        	}
	            passthru($cmd);
	        }
        }
    } //MakeCaptcha

    function getCaptchaString () {
        global $cString;

        if ( $this->driver == 2 ) { // static images
			return $cString[$this->CaptchaString];
		}
        return $this->CaptchaString;
    } //GetCaptchaString
} //class: captcha
?>